﻿<!-- ------------------------------------------------- 
Exemplo de codigo php - Formulário de pagamento
VERSION 1.0a - Lyra Network
------------------------------------------------------ -->

<?php


/**
 * PHP is not yet a sufficiently advanced technology to be indistinguishable from magic...
 * so don't use magic_quotes, they mess up with the gateway response analysis.
 * 
 * @param array $potentiallyMagicallyQuotedData
 */
function uncharm($potentiallyMagicallyQuotedData) {
			if (get_magic_quotes_gpc()) {
				$sane = array();
				foreach ($potentiallyMagicallyQuotedData as $k => $v) {
					$saneKey = stripslashes($k);
					$saneValue = is_array($v) ? SystempayApi::uncharm($v) : stripslashes($v);
					$sane[$saneKey] = $saneValue;
				}
			} else {
				$sane = $potentiallyMagicallyQuotedData;
			}
			return $sane;
		}

/*--------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------
FONCTION => Exemplo de geração do trans_id com base em um contador.
Trans_id é a identificação do transação e deve ser:
		- valor único por dia
		- entre 000000 et 899999
		- de comprimento 6 ( 6 caracteres )
---------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------*/

function get_Trans_id() {
// Neste exemplo, o valor do contador é armazenada num arquivo texto (count.txt), incrementado por 1 até o limite de 899.999, no limite o valor retorna a 0 (ZERO)
// Abrindo/travando 
$filename = "./contador/count.txt";// Aqui indicamos o caminho do arquivo.
$fp = fopen($filename, 'r+');
flock($fp, LOCK_EX);

// lendo/incrementando
$count = (int)fread($fp, 6);    // (int) = convertendo para inteiro.
$count++;
if($count < 0 || $count > 899999) {
    $count = 0;
}

// Voltando ao início do arquivo
fseek($fp, 0);
ftruncate($fp,0);

// escrevendo/encerrando/Fim do bloqueio
fwrite($fp, $count);
flock($fp, LOCK_UN);
fclose($fp);

// Campo trans_id : Adiciona 0 no início se necessário
$trans_id = sprintf("%06d",$count);
return($trans_id);
}

// -------------------------------------------------------------------------------------------------------------------

/*--------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------
FONCTION => CALCULO DA ASSINATURA
---------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------*/
function get_Signature($field,$key) {

ksort($field); // parâmetros em ordem alfabética
$contenu_signature = "";
foreach ($field as $nom => $valeur)
{
	if(substr($nom,0,5) == 'vads_') {
	$contenu_signature .= $valeur."+";
	}
}
$contenu_signature .= $key;	// Acrescenta o certificado no final da string.
$signature = sha1($contenu_signature);
return($signature);

}

//--------------------------------------------------------------------------------------------------------------------


/*--------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------
FUNCTION => CONTROLE DA ASSINATURA RECIBIDA
---------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------*/
function Check_Signature($field,$key) {
$result='false';

$signature=get_Signature($field,$key);

if(isset($field['signature']) && ($signature == $field['signature']))
{
	$result='true';
	
}
return ($result);
}

//--------------------------------------------------------------------------------------------------------------------


/*--------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------
FUNCTION => GERAÇÃO DE TODOS OS CAMPOS DO FORMULÁRIO PARA ENVIO À PLATAFORMA
Os campos devem ser codificados no formato UTF-8. Apenas os campos começando com vads_xxxx são enviados.
---------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------*/
function get_formHtml_request($field,$key) {


$params=array();
		foreach ($field as $nom => $valeur)
		{
			if(substr($nom,0,5) == 'vads_') {
			//$params[$nom]=	utf8_encode($valeur);
			$params[$nom]=($valeur);
			}
		}
$params['vads_trans_id']=get_Trans_id();
$params['vads_trans_date'] = gmdate ("YmdHis", time());
$params['signature'] = get_Signature($params,$key);

$form= '<form method="POST" action="https://secure.payzen.com.br/vads-payment/">';
$form.= 'INFORMAR OS VALORES PARA SEREM ENVIADOS À PLATAFORMA DE PAGAMENTO <br/>';
foreach ($params as $nom => $valeur)
		{
			$form.=$nom.' : '.$valeur.'<br/>';
			$form.='<input type="hidden" name="' . $nom . '" value="' . $valeur . '" />';	
		}
$form.='<button type="submit" class="validationButton" >';
$form.=	'<span><em>PAGAR => Enviar as informações para plataforma de pagamento</em></span>';
$form.='</button>';
return($form);

}
//----------------------------------------------------------------------------------------------------------------------


?>